$Title  A Factory Problem (TASK1,SEQ=1)
$Ontext
         1b. This problem about factory, products and minerals.
         Author: Arykov Nikita, group 9205.
$Offtext

  Sets
       i   products   / product1, product2 /
       j   minerals   / mineralA, mineralB / ;

  Parameters
       b(j)  capacity of mineral j in cases
         /    mineralA     100000
              mineralB     30000  /
       costM(j) cost of buying 1 tonne of mineral j
         /    mineralA     3.25
              mineralB     3.40 /
       costP(i) cost of buying 1 tonne of product i
         / product1 5.75
           product2 4.00 /
       convertMatrix(i) how convertor converting 1 tonne of product2
         / product1 0.5
           product2 0.5 /
  Table
         T(j,i) reprocessing from mineral to product matrix in tonne
                           product1  product2
         mineralA            0.15       0.85
         mineralB            0.25       0.75
  Scalar
         costProduct2ForSale        /3.80/
         costProduct1ForSaleUntil45 /5.5/
         costProduct1ForSaleUntil49 /5.2/
         costProduct1ForSaleAfter49 /5.0/
         minForProduct1   in contract write what we owes sale 40000 tonne of product1 /40000/
         maxPowerConveyor power in tonne of conveyor in day  /100000/
         maxPoverConvertor power in tonne of convertor in day  /50000/
         costOfUseConveyour cost of converter one tonne mineral /0.35/
         costOfUseConvertor cost of converter one tonne mineral /0.25/
         costOfFilter cost of filtering one tonnee product1 from main proccesing /0.10/
         capacity1Product1 limit1 to sell product1 /45000/
         capacity2Product1 limit1 to sell product1 /4000/;

  Variables
       buyMineral(j)  count of minerals j in tonne
       productBuying(i) count of product i which we buying

       productAfterConveyor(i)  count of product i after reproccessing on conveyor
       product2ForConvertor     count of product2 to convert in tonne
       product2ForSale          count of product2 to sell in tonne
       productAfterConvertor(i) count of product i after converting product2 on convertor

       product1Before45 count of product1 before 45 tonne
       product1After45Before49 count of product1 after 45 and before 49 tonne
       product1After49 count of product1 after 49 tonne

       product1AfterFilter

       spendMoneyOnBuyProductAndMineral
       spendMoneyOnConveyour
       spenMoneyOnConvertionProduct2
       spendMoneyOnFiltering

       spendMoney   total spend money
       getMoney     total get money
       totalProfit
  ;

  Positive Variable buyMineral, productBuying, productAfterConveyor, product2ForConvertor, productAfterConvertor,
                    product1Before45, product1After45Before49, product1After49, product2ForSale,
                    product1AfterFilter, spendMoneyOnBuyProductAndMineral, spendMoneyOnConveyour, spenMoneyOnConvertionProduct2, spendMoneyOnFiltering,
                    spendMoney, getMoney;

  Equations
       limit1(j)
       limit_power_conveyor
       limit_power_convertor
       limit_min_make_product1
       limit2
       limit3
       limit4
       limit5(i)
       limit6
       limit7
       limit8(i)
       limit9
       limit10
       limit11
       limit12
       limit13
       limit14
       total_goal
  ;

* Product1:  productBuying("product1"), productAfterConveyor("product1"), productAfterConvertor("product1")
* Product2:  productBuying("product2"), productAfterConveyor("product2"), productAfterConvertor("product2"), product2ForSale, product2ForConvertor

  limit1(j)               ..   buyMineral(j) =l= b(j);
  limit_power_conveyor    ..   sum(j, buyMineral(j)) =l= maxPowerConveyor;
  limit_power_convertor   ..   product2ForConvertor  =l= maxPoverConvertor;

  limit_min_make_product1 ..   productAfterConveyor("product1") + productAfterConvertor("product1") + productBuying("product1") =g= minForProduct1;
  limit2                  ..   product1Before45        =l= capacity1Product1;
  limit3                  ..   product1After45Before49 =l= capacity2Product1;

  limit4                  ..   productBuying("product2") + productAfterConveyor("product2") =e= product2ForSale + product2ForConvertor;

  limit5(i)               ..   productAfterConveyor(i) =e= sum(j, T(j,i) * buyMineral(j));
  limit6                  ..   spendMoneyOnBuyProductAndMineral =e= sum(i, productBuying(i)*costP(i)) + sum(j, buyMineral(j)*costM(j));
  limit7                  ..   spendMoneyOnConveyour =e= sum(j, buyMineral(j)) * costOfUseConveyour;

  limit8(i)               ..   productAfterConvertor(i) =e= product2ForConvertor * convertMatrix(i);
  limit9                  ..   spenMoneyOnConvertionProduct2 =e= product2ForConvertor * costOfUseConvertor;

  limit10                 ..   product1AfterFilter   =e= productAfterConvertor("product1") + productAfterConveyor("product1");
  limit11                 ..   spendMoneyOnFiltering =e= product1AfterFilter * costOfFilter;

  limit12                 ..   product1Before45 + product1After45Before49 + product1After49 =e= productBuying("product1") + product1AfterFilter;

  limit13                 ..   spendMoney =e= spendMoneyOnBuyProductAndMineral + spendMoneyOnConveyour + spenMoneyOnConvertionProduct2 + spendMoneyOnFiltering;

  limit14                 ..   getMoney   =e= costProduct1ForSaleUntil45 * product1Before45  + costProduct1ForSaleUntil49 * product1After45Before49
                                                         + costProduct1ForSaleAfter49 * product1After49
                                                          + costProduct2ForSale*(product2ForSale + productAfterConvertor("product2"));

  total_goal              ..   totalProfit =e= getMoney - spendMoney;

  Model M1 /all/ ;

  Solve M1 using lp maximizing totalProfit;

  Display productBuying.l, buyMineral.l,
         productAfterConveyor.l, product2ForConvertor.l, product2ForSale.l, productAfterConvertor.l, product1AfterFilter.l,
         product1Before45.l, product1After45Before49.l, product1After49.l,
         spendMoneyOnBuyProductAndMineral.l, spendMoneyOnConveyour.l, spenMoneyOnConvertionProduct2.l, spendMoneyOnFiltering.l,
         spendMoney.l, getMoney.l, totalProfit.l;
